//6,7,8,9,10
//6 start R
//7 start L
//8 start R gun
//9 start L gun
//10 reset R
//11 reset L

#include <SPI.h>
#include "RF24.h"
// nastaven? propojovac?ch pin?

#define CE 7
#define CS 8
RF24 nRF(CE, CS);
const byte addresses[][6] = {"00001", "00002"};



#include <Wire.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27, 20, 4);


struct Track
{
  int id;
  int gStart;
  int bStart;
  int bReset;
  unsigned long long startTime = 0;
  unsigned long long rStopTime = 0;
  unsigned long long lStopTime = 0;
};

byte z[8] = {B01010, B00100, B11111, B00010, B00100, B01000, B11111, B00000};
byte y[8] = {B00010, B00100, B10001, B10001, B01111, B00001, B01110, B00000};
struct Track rTrack;
struct Track lTrack;

void setup()
{


  nRF.begin();

nRF.openWritingPipe(addresses[1]);
  nRF.openReadingPipe(1, addresses[0]);
 nRF.setPALevel(RF24_PA_LOW);
  nRF.startListening();

  lcd.begin();
  lcd.backlight();
  lcd.createChar(0, z);
  lcd.createChar(1, y);


  writeText();
  rTrack.id = 0;
  rTrack.gStart = 1;
  rTrack.bStart = 2;
  rTrack.bReset = 3;

  pinMode(rTrack.gStart, INPUT);
  pinMode(rTrack.bStart, INPUT);
  pinMode(rTrack.bReset, INPUT);
  //Left Track
  lTrack.id = 1;
  lTrack.gStart = 4;
  lTrack.bStart = 5;
  lTrack.bReset = 6;

  pinMode(lTrack.gStart, INPUT);
  pinMode(lTrack.bStart, INPUT);
  pinMode(lTrack.bReset, INPUT);

}

void loop()
{


  //start
  if ((digitalRead(rTrack.bStart) || digitalRead(rTrack.gStart)))
    runTrack(&rTrack);
  //reset
  else  if (digitalRead(rTrack.bReset))
   { resetTrack(5);
    resetTrack(6);
   }
  int request;

  if ( nRF.available()) {
    while (nRF.available()) {
      nRF.read( &request, sizeof(request) );
    }
//todo
    lcd.println(request);
    switch ( request ) {
      case 1:
        lcd.setCursor(0, 0);
        lcd.print("1-stop pravy");
        break;
      case 2:
        lcd.setCursor(1, 0);
        lcd.print("1-stop levy");
        break;
      case 3:
        lcd.setCursor(2, 0);
        lcd.print("2-stop pravy");
        break;
      case 4:
        lcd.setCursor(3, 0);
        lcd.print("3-stop levy");
        break;
      default:
        break;
    }
  }
}
void runTrack(Track * t)
{
  lcd.setCursor ( 0, 2);
  lcd.print("strat track R");

}

void resetTrack(int code)
{
  int response;
  response = code;
  nRF.stopListening();
  nRF.write( &response, sizeof(response) );
  nRF.startListening();
  lcd.setCursor ( 0, 2);
  lcd.print("reset track R");

}



void  writeText()
{ /*
    lcd.setCursor(3, 0);
    lcd.print("SDH Sendra");
    lcd.write(byte(0));
    lcd.print("ice");

    lcd.setCursor(5, 1);
    lcd.print("00:00:000");

    lcd.setCursor(0, 2);
    lcd.print("Prav");
    lcd.write(byte(1));
    lcd.print(": 00:00:000");

    lcd.setCursor(0, 3);
    lcd.print("Lev");
    lcd.write(byte(1));
    lcd.print(":  00:00:000");*/


  lcd.setCursor(0, 0);
  lcd.print("Trat 1 prav");
  lcd.write(byte(1));
  lcd.print("00:00:00");

  lcd.setCursor(0, 1);
  lcd.print("Trat 1 lev");
  lcd.write(byte(1));
  lcd.print(" 00:00:00");

  lcd.setCursor(0, 2);
  lcd.print("Trat 2 prav");
  lcd.write(byte(1));
  lcd.print("00:00:00");

  lcd.setCursor(0, 3);
  lcd.print("Trat 2 lev");
  lcd.write(byte(1));
  lcd.print(" 00:00:00");



}

bool ValueNumber(int n)
{
  if (n < 10)
    return true;
  return false;
}

















