#include <SPI.h>
#include "RF24.h"

#define CE 7
#define CS 8
RF24 nRF(CE, CS);
//addresses pipe
const byte addresses[][6]={"00001","00002"};


struct Switch
{
  int id;
  int sensor;
  int led;
  boolean bliking = false;
  unsigned long long lastTimeBliking = 0;
};

struct Track
{
  struct Switch right;
  struct Switch left;
};

struct Track trackOne;
struct Track trackTwo;


void setup() {

  Serial.begin(9600);
  nRF.begin();
  
  nRF.openWritingPipe(addresses[0]);
  nRF.openReadingPipe(1,addresses[1]);
	nRF.setPALevel(RF24_PA_LOW);
  nRF.startListening();

  trackOne.right.id = 1;
  trackOne.right.sensor = 1;
  trackOne.right.led = 5;

  trackOne.left.id = 2;
  trackOne.left.sensor = 2;
  trackOne.left.led = 6;

  //left track
  trackTwo.right.id = 3;
  trackTwo.right.sensor = 3;
  trackTwo.right.led = 9;

  trackTwo.left.id = 4;
  trackTwo.left.sensor = 4;
  trackTwo.left.led = 10;

  pinMode(trackOne.right.sensor, INPUT);
  pinMode(trackOne.left.sensor, INPUT);
  pinMode(trackOne.right.led, OUTPUT);
  pinMode(trackOne.left.led, OUTPUT);

  pinMode(trackTwo.right.sensor, INPUT);
  pinMode(trackTwo.left.sensor, INPUT);
  pinMode(trackTwo.right.led, OUTPUT);
  pinMode(trackTwo.left.led, OUTPUT);

  digitalWrite(trackOne.right.led, LOW);//IN1
  digitalWrite(trackOne.left.led, LOW);//IN2
  digitalWrite(trackTwo.right.led, LOW);//IN3
  digitalWrite(trackTwo.left.led, LOW);//IN4
}
void loop() {

  if (!digitalRead(trackOne.right.sensor) && !trackOne.right.bliking)
  {
    switchSensor(&trackOne.right);
    Serial.println("Pravy terc trate 1 sepnul");
  }
  else if (!digitalRead(trackOne.left.sensor) && !trackOne.left.bliking)
  {
    switchSensor(&trackOne.left);
    Serial.println("Levy terc trate 1 sepnul");
  }
  else if (!digitalRead(trackTwo.right.sensor) && !trackTwo.right.bliking)
  {
    switchSensor(&trackTwo.right);
    Serial.println("Pravy terc trate 2 sepnul");
  }
  else if (!digitalRead(trackTwo.left.sensor) && !trackTwo.left.bliking)
  {
    switchSensor(&trackTwo.left);
     resetTrack(&trackOne);
     
        resetTrack(&trackTwo);
    Serial.println("Levy terc trate 2 sepnul");
  }


  int request;
  if ( nRF.available()) {
    while (nRF.available()) {
      nRF.read( &request, sizeof(request) );
    }
    switch ( request ) {
      case 5:
        resetTrack(&trackOne);
        break;
      case 6:
        resetTrack(&trackTwo);
        break;
      default:
        break;
    }

  }
}

void switchSensor(Switch *s)
{
  int response;
  response = (*s).id;
  nRF.stopListening();
  nRF.write( &response, sizeof(response) );
  nRF.startListening();
  (*s).bliking = true;
  (*s).lastTimeBliking = millis();
  digitalWrite((*s).led, true);
}

//reset
void resetTrack(Track *t)
{
	//todo
  Serial.println("reset trate");
  resetSwitch(&(*t).right);
  resetSwitch(&(*t).left);
}
void resetSwitch(Switch *s)
{
  (*s).bliking = false;
  (*s).lastTimeBliking = 0;
  digitalWrite((*s).led, false);
}

/*
  void bliking()
  {
    unsigned long long now = millis();

    if (now - lastTime > 250) {
      lastTime = now;
      lights = false;
    }
    else if (now - lastTime > 250) {
      lastTime = now;
      lights = true;
    }

    if (rTrack.rBliking)
      digitalWrite(rTrack.rLed, lights);
    else
      digitalWrite(rTrack.rLed, false);

    if (rTrack.lBliking)
      digitalWrite(rTrack.lLed, lights);
    else
      digitalWrite(rTrack.lLed, false);

    if (lTrack.rBliking)
      digitalWrite(lTrack.rLed, lights);
    else
      digitalWrite(lTrack.rLed, false);

    if (lTrack.lBliking)
      digitalWrite(lTrack.lLed, lights);
    else
      digitalWrite(lTrack.lLed, false);
  }*/
