// nRF24L01 p?ijma?

#include <SPI.h>
#include "RF24.h"
#define CE 7
#define CS 8
RF24 nRF(CE, CS);
byte adresaPrijimac[]= "prijimac00";
byte adresaVysilac[]= "vysilac00";

void setup() {
  Serial.begin(9600);
  nRF.begin();
  nRF.setPALevel(RF24_PA_LOW);
  nRF.openWritingPipe(adresaPrijimac);
  nRF.openReadingPipe(1,adresaVysilac);
  nRF.startListening();
}

void loop() {
  int prijem;
  unsigned long odezva;
  if( nRF.available()){
    while (nRF.available()) {
      nRF.read( &prijem, sizeof(prijem) );
    }
    Serial.print("Prijata volba: ");
    Serial.print(prijem);
    switch( prijem ) {
      case 1:
        // v p?pad? 1 ode?li po?et milisekund
        // od p?ipojen napjen
        odezva = millis();
        break;
      case 2:
        // v p?pad? 2 po?et sekund
        // od p?ipojen napjen
        odezva = millis()/1000;
        break;
      case 3:
        // v p?pad? 3 po?et mikrosekund
        // od p?ipojen napjen
        odezva = micros();
        break;
      // v p?pad? ostatnch dat bude odezva 0
      default:
        odezva = 0;
        break;
    }
    // ukon?en p?jmu dat
    nRF.stopListening();
    // odesln odezvy 
    nRF.write( &odezva, sizeof(odezva) );     
    // p?epnut do p?jmu dat pro dal? komunikaci
    nRF.startListening();
    // vyti?t?n odezvy po sriov lince     
    Serial.print(", odezva: ");
    Serial.println(odezva);  
  }
}